unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, AppEvnts, Sockets,
  k3ks_initools,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    ed_ip: TEdit;
    label24: TLabel;
    ed_thr: TEdit;
    label100: TLabel;
    ed_rep: TEdit;
    ud_thr: TUpDown;
    ud_rep: TUpDown;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    ed_req: TEdit;
    ud_req: TUpDown;
    Timer1: TTimer;
    Timer2: TTimer;
    Label1: TLabel;
    Label3: TLabel;
    ed_port: TEdit;
    ud_port: TUpDown;
    mem_cmd: TMemo;
    Bevel1: TBevel;
    Label4: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    ed_log: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    Bevel2: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { Private declarations }
    FID:integer;
    FStarted,FStopAll:boolean;
    FThreads:TList;
    procedure ShowStat;
    procedure StartIt;
    procedure StopIt;
  public
    { Public declarations }
  end;


var
 Form1: TForm1;


implementation

uses SyncObjs,Unit2,k3ks_application;

{$R *.dfm}

var
 Datas:array[0..4] of variant;

procedure TForm1.FormCreate(Sender: TObject);
var ini:TK3KSRegIniFile;alls,s:string;SL:TStringList;
begin
{
 with TIdHTTP.Create(nil) do begin
  Host:='http://127.0.0.1';
  //ShowMessage(Get(Host+''));
  SL:=TStringList.Create;SL.Text:='input=alfa&submit=true';
  ShowMessage(Post(Host+'/cgi-bin/OnPost.py',SL));
 end;
 Exit;}
 Ini:=K3KSApplicationIni;
 Ini.Path:='\\params';
 ed_ip.Text:=Ini.ReadString('address','http://127.0.0.1');
 ud_port.Position:=Ini.ReadInteger('port',80);
 ud_thr.Position:=Ini.ReadInteger('maxthreads',1);
 ud_rep.Position:=Ini.ReadInteger('repeat',500);
 ud_req.Position:=Ini.ReadInteger('requests',10);
 ed_log.Text:=Ini.ReadString('logdir','');
 Ini.Path:='\\commands';
 SL:=TStringList.Create;
 try
  Ini.GetSectionValues(SL);
  mem_cmd.Lines.Assign(SL);
 finally
  SL.Free;
 end;
 FThreads:=TList.Create;
 Datas[3]:=Null;Datas[4]:=Null;
 ShowStat;
end;

procedure TForm1.ShowStat;
begin
 Label6.Caption:=IntToStr(FThreads.Count);
 Label8.Caption:=IntToStr(Datas[0]);
 Label10.Caption:=IntToStr(Datas[1]);
 Label12.Caption:=IntToStr(Datas[2]);
 if not VarIsNull(Datas[3])
  then Label14.Caption:=DateTimeToStr(Datas[3])
  else Label14.Caption:='-';
 if not VarIsNull(Datas[4])
  then Label16.Caption:=DateTimeToStr(Datas[4])
  else Label16.Caption:='-';
 if VarIsNull(Datas[3]) or VarIsNull(Datas[4])
  then Label19.Caption:='-'
  else Label19.Caption:=TimeToStr(Datas[4]-Datas[3]);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 StartIt;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 StopIt;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 StopIt;
 Close;
end;

procedure TForm1.StartIt;
var i:integer;F:integer;SR:TSearchRec;
begin
 if FStarted then Exit;
 FID:=1;
 ed_log.Text:=ExcludeTrailingPathDelimiter(ed_log.Text);
 if (ed_log.Text<>'') then begin
  F:=FindFirst(ed_log.Text+'\*.*',faanyfile,SR);
  while (F=0) do begin
   if (SR.Attr and faDirectory)=0 then begin
    DeleteFile(ed_log.Text+'\'+SR.Name);
   end;
   F:=FindNext(SR);
  end;
  FindClose(SR);
 end; 
 Button1.Enabled:=False;Button3.Enabled:=True;
 GroupBox1.Enabled:=False;
 for i:=0 to High(Datas) do Datas[i]:=0;
 ShowStat;
 FStopAll:=False;
 FStarted:=True;
 Timer1.Interval:=ud_rep.Position;
 Timer1.Enabled:=true;
 Timer1Timer(nil);
 Datas[4]:=Null;
 Datas[3]:=Now;
 ShowStat;
end;

procedure TForm1.StopIt;
var i:integer;Thr:THTTPGetThread;bQuit:boolean;
begin
 if not FStarted then Exit;
 FStopAll:=True;
 Timer1.Enabled:=False;
 // Signaling
 for i:=0 to FThreads.Count-1 do begin
  Thr:=FThreads[i];
  if (Thr.State<>-1) then Thr.Terminate;
 end;
 // Destroy all threads
 repeat
  bQuit:=True;
  for i:=0 to FThreads.Count-1 do begin
   Thr:=FThreads[i];if Thr=nil then Continue;
   if (Thr.State<>-1)
    then bQuit:=False
    else begin
     FThreads[i]:=nil;
     Thr.Free;
    end;
  end;
  FThreads.Pack;
  Sleep(0);
 until bQuit;
 FThreads.Clear;
 FStarted:=False;
 Button1.Enabled:=True;Button3.Enabled:=False;
 GroupBox1.Enabled:=True;
 Datas[4]:=Now;
 ShowStat;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var Thr:THTTPGetThread;
begin
 if FStopAll then Exit;
 if (ud_thr.Position<=FThreads.Count) then Exit;
 Thr:=THTTPGetThread.Create(True);
 FThreads.Add(Thr);
 try
  with Thr do begin
   ID:=self.FID;inc(self.FID);
   IPAddr:=ed_ip.Text;
   Commands:=mem_cmd.Lines.Text;
   while Suspended do begin
    Sleep(0);     
    Resume;
   end;
  end;
  inc(Datas[0]);
  if (Datas[0]>ud_req.Position) then FStopAll:=True;
  ShowStat;
 except
 end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 FThreads.Free;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var i,j:integer;Thr:THTTPGetThread;s,logdir:string;
begin
 if not FStarted then Exit;
 logdir:=ed_log.Text;
 for i:=0 to FThreads.Count-1 do begin
  Thr:=FThreads[i];if Thr=nil then Continue;
  if (Thr.State=-1) then begin
   if (Thr.Error<>0) then inc(Datas[2]) else inc(Datas[1]);
   if (logdir<>'') then begin
    if (Thr.Logs<>nil) then begin
     for j:=0 to High(Thr.Logs) do begin
      with TStringList.Create do begin
       try
        Text:=Thr.Logs[j];
        s:=logdir+'/LOG_'+FormatFloat('000000',Thr.ID)+'_'+FormatFloat('00',j+1)+'.html';
        SaveToFile(s);
       finally
        Free;
       end;
      end;
     end;
    end; 
   end;
   FThreads[i]:=nil;
   Thr.Free;
  end;
 end;
 FThreads.Pack;
 if (Datas[0]=ud_req.Position) then FStopAll:=True;
 if FStopAll and (FThreads.Count=0) then StopIt;
 ShowStat;
end;

end.
